#include "stdafx.h"
#include <windows.h>
#include <stdio.h>

LARGE_INTEGER liFrequency;
LARGE_INTEGER liPreviousTicks;
bool bFirst = true;	

VOID CALLBACK CallbackFunction(PVOID lpParameter, BOOLEAN TimerOrWaitFired)
{
	double dElapsed;
	LARGE_INTEGER liCurrentTicks;
		
	if (bFirst)
	{
		QueryPerformanceCounter(&liPreviousTicks);
		bFirst = false;
	}
	else
	{
		QueryPerformanceCounter(&liCurrentTicks);
		dElapsed = (liCurrentTicks.QuadPart - liPreviousTicks.QuadPart)
			* 1000.0 / liFrequency.QuadPart;
		printf("Period time: %fms\n", dElapsed);
		liPreviousTicks = liCurrentTicks;
	}
}

int _tmain(int argc, char* argv[])
{
	HANDLE hTimer;

	QueryPerformanceFrequency(&liFrequency);

	if (!CreateTimerQueueTimer(&hTimer, NULL, CallbackFunction, NULL, 0, 50, 0))
	{
		fprintf(stderr, "Error en la creacin del temporizador: %d\n", GetLastError());
		return 1;
	}

	// Esperamos un tiempo
	Sleep(1000);

	DeleteTimerQueueTimer(NULL, hTimer, NULL);
	return 0;
}
